unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBCtrls, DBTables, StdCtrls, ExtCtrls, Word2000, OleServer,
  ADODB;

type
  TForm1 = class(TForm)
    WordApplication1: TWordApplication;
    WordDocument1: TWordDocument;
    DBLookupComboBox2: TDBLookupComboBox;
    DBLookupComboBox1: TDBLookupComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    ADOQuery2: TADOQuery;
    DataSource1: TDataSource;
    ADOQuery1OrderNo: TFloatField;
    ADOQuery1CustNo: TFloatField;
    ADOQuery1empno: TIntegerField;
    ADOQuery1LastName: TWideStringField;
    ADOQuery1FirstName: TWideStringField;
    ADOQuery1SaleDate: TDateTimeField;
    ADOQuery1ShipDate: TDateTimeField;
    ADOQuery1ShipVIA: TWideStringField;
    ADOQuery1Freight: TFloatField;
    ADOQuery1Company: TWideStringField;
    ADOQuery1Addr1: TWideStringField;
    ADOQuery1Addr2: TWideStringField;
    ADOQuery1City: TWideStringField;
    ADOQuery1State: TWideStringField;
    ADOQuery1Zip: TWideStringField;
    ADOQuery1Country: TWideStringField;
    ADOQuery2PartNo: TFloatField;
    ADOQuery2OrderNO: TFloatField;
    ADOQuery2Description: TWideStringField;
    ADOQuery2Qty: TIntegerField;
    ADOQuery2ListPrice: TFloatField;
    ADOQuery2Discount: TFloatField;
    ADOQuery2amount: TFloatField;
    procedure insertoneLine;
    procedure repl(source,repl_text:string);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBLookupComboBox1CloseUp(Sender: TObject);
    procedure DBLookupComboBox2CloseUp(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    qs1,qs2:string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.insertoneLine;
var _NumberRows:OleVariant;
begin
   _NumberRows:=1;
   WordApplication1.Selection.InsertRowsBelow(_NumberRows);
end;

procedure TForm1.repl(source,repl_text:string);
var _Text,_MatchCase,_MatchWholeWord,_MatchWildcards,_MatchSoundsLike,
    _MatchAllWordForms,_Forward,_Wrap,_Format,_ReplaceWith,_Replace,
    _MatchKashida,_MatchDiacritics,_MatchAlefHamza,_MatchControl:OleVariant;
begin
   WordApplication1.Selection.Find.ClearFormatting;
   _Text :=source;
   _MatchCase := False;
   _MatchWholeWord := False;
   _MatchWildcards := False;
   _MatchSoundsLike := False;
   _MatchAllWordForms:=EmptyParam;
   _Forward := True;
   _Wrap := wdFindContinue;
   _Format := False;
   _Replace:=wdReplaceOne;
   _ReplaceWith:=repl_text;
   _MatchKashida:=EmptyParam;
   _MatchDiacritics:=EmptyParam;
   _MatchAlefHamza:=EmptyParam;
   _MatchControl:=EmptyParam;
   WordApplication1.Selection.Find.Execute(_Text,_MatchCase,_MatchWholeWord,
      _MatchWildcards,_MatchSoundsLike,_MatchAllWordForms,_Forward,_Wrap,
      _Format,_ReplaceWith,_Replace,_MatchKashida,_MatchDiacritics,
      _MatchAlefHamza,_MatchControl);
end;

procedure TForm1.Button2Click(Sender: TObject);
var Template,ItemIndex:OleVariant;
    s:string;
    i,j,k:integer;
    sum:real;
begin
   s:=extractfilepath(application.ExeName)+'invoice2.doc';
   if Fileexists(s) then
   begin
      Template:=s;
      WordApplication1.Documents.Open(template,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
      ItemIndex:=1;
      WordDocument1.ConnectTo(WordApplication1.Documents.Item(ItemIndex));
      WordApplication1.Visible:= True;
      WordDocument1.Range.Select;
      WordDocument1.Range.Cut;
      ADOQuery1.Active:=false;
      if qs1='' then
         ADOQuery1.SQL.Strings[3]:=''
      else
         ADOQuery1.SQL.Strings[3]:='  and a.OrderNo>='+qs1;
      if qs2='' then
         ADOQuery1.SQL.Strings[4]:=''
      else
         ADOQuery1.SQL.Strings[4]:='  and a.OrderNo<='+qs2;
      ADOQuery1.active:=true;
      ADOQuery2.Active:=true;
      ADOQuery1.First;
      i:=0;  //table 
      while not ADOQuery1.Eof do
      begin
         Worddocument1.Range.Characters.Last.select;
         Worddocument1.Range.Characters.Last.paste;
         i:=i+1;
         WordDocument1.Tables.Item(i).Cell(1,1).Select;
         repl('Company_name',ADOQuery1.fieldbyname('company').asstring);
         repl('Address1',ADOQuery1.fieldbyname('Addr1').asstring+','+ADOQuery1.fieldbyname('Addr2').asstring);
         repl('Address2',ADOQuery1.fieldbyname('City').asstring+','+ADOQuery1.fieldbyname('State').asstring+','+ADOQuery1.fieldbyname('Zip').asstring);
         repl('Address3',ADOQuery1.fieldbyname('Country').asstring);
         WordDocument1.Tables.Item(i).Cell(3,1).Range.Text:=ADOQuery1.fieldbyname('OrderNO').asstring;
         WordDocument1.Tables.Item(i).Cell(3,2).Range.Text:=ADOQuery1.fieldbyname('CustNO').asstring;
         WordDocument1.Tables.Item(i).Cell(3,3).Range.Text:=ADOQuery1.fieldbyname('LastName').asstring+' '+ADOQuery1.fieldbyname('FirstName').asstring;
         WordDocument1.Tables.Item(i).Cell(3,4).Range.Text:=ADOQuery1.fieldbyname('SaleDate').asstring;
         WordDocument1.Tables.Item(i).Cell(3,5).Range.Text:=ADOQuery1.fieldbyname('ShipDate').asstring;
         WordDocument1.Tables.Item(i).Cell(3,6).Range.Text:=ADOQuery1.fieldbyname('ShipVia').asstring;
         j:=5;
         sum:=0;
         While not ADOQuery2.Eof do
         begin
            WordDocument1.Tables.Item(i).Cell(j,1).Range.Text:=ADOQuery2.fieldbyname('PartNO').asstring;
            WordDocument1.Tables.Item(i).Cell(j,2).Range.Text:=ADOQuery2.fieldbyname('Description').asstring;
            WordDocument1.Tables.Item(i).Cell(j,3).Range.Text:=ADOQuery2.fieldbyname('Qty').asstring;
            WordDocument1.Tables.Item(i).Cell(j,4).Range.Text:=formatfloat('###,####.#0',ADOQuery2.fieldbyname('ListPrice').asfloat);
            WordDocument1.Tables.Item(i).Cell(j,5).Range.Text:=formatfloat('###,####.##',ADOQuery2.fieldbyname('Discount').AsFloat);
            WordDocument1.Tables.Item(i).Cell(j,6).Range.Text:=formatfloat('###,####.#0',ADOQuery2.fieldbyname('amount').AsFloat);
            sum:=sum+ADOQuery2.fieldbyname('amount').AsFloat;
            j:=j+1;
            ADOQuery2.Next;
         end;
         WordDocument1.Tables.Item(i).Cell(30,2).Range.Text:=formatfloat('###,####.#0',sum);
         WordDocument1.Tables.Item(i).Cell(31,2).Range.Text:=formatfloat('###,####.#0',ADOQuery1.fieldbyname('Freight').AsFloat);
         WordDocument1.Tables.Item(i).Cell(32,2).Range.Text:=formatfloat('###,####.#0',sum+ADOQuery1.fieldbyname('Freight').AsFloat);
         ADOQuery1.Next;
      end;
      WordDocument1.Range.Characters.Last.Delete(emptyparam,ItemIndex);
      WordDocument1.Disconnect;
      WordApplication1.Disconnect;
      ADOQuery1.Active:=false;
      ADOQuery1.SQL.Strings[3]:='';
      ADOQuery1.SQL.Strings[4]:='';
      ADOQuery1.Active:=true;
   end else
   begin
      showmessage('Lk'+s);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   ADOquery1.Active:=true;
end;

procedure TForm1.DBLookupComboBox1CloseUp(Sender: TObject);
begin
   qs1:=DBLookupComboBox1.Text;
end;

procedure TForm1.DBLookupComboBox2CloseUp(Sender: TObject);
begin
   qs2:=DBLookupComboBox2.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Template,ItemIndex,_Type:OleVariant;
    s:string;
    i,j,k:integer;
    sum:real;
begin
   _Type:=wdSectionBreakNextPage;
   s:=extractfilepath(application.ExeName)+'invoice.doc';
   if Fileexists(s) then
   begin
      Template:=s;
      WordApplication1.Documents.Open(template,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
      ItemIndex:=1;
      WordDocument1.ConnectTo(WordApplication1.Documents.Item(ItemIndex));
      WordApplication1.Visible:= True;
      WordDocument1.Range.Select;
      WordDocument1.Range.Cut;
      ADOQuery1.Active:=false;
      if qs1='' then
         ADOQuery1.SQL.Strings[3]:=''
      else
         ADOQuery1.SQL.Strings[3]:='  and a.OrderNo>='+qs1;
      if qs2='' then
         ADOQuery1.SQL.Strings[4]:=''
      else
         ADOQuery1.SQL.Strings[4]:='  and a.OrderNo<='+qs2;
      ADOQuery1.active:=true;
      ADOQuery2.Active:=true;
      ADOQuery1.First;
      i:=0;  //table 
      while not ADOQuery1.Eof do
      begin
         Worddocument1.Range.Characters.Last.select;
         Worddocument1.Range.Characters.Last.paste;
         i:=i+1;
         if i>1 then
         begin
            WordDocument1.Tables.Item(i).Select;
            WordApplication1.Selection.InsertBreak(_Type);
         end;
         WordDocument1.Tables.Item(i).Cell(1,1).Select;
         repl('Company_name',ADOQuery1.fieldbyname('company').asstring);
         repl('Address1',ADOQuery1.fieldbyname('Addr1').asstring+','+ADOQuery1.fieldbyname('Addr2').asstring);
         repl('Address2',ADOQuery1.fieldbyname('City').asstring+','+ADOQuery1.fieldbyname('State').asstring+','+ADOQuery1.fieldbyname('Zip').asstring);
         repl('Address3',ADOQuery1.fieldbyname('Country').asstring);
         WordDocument1.Tables.Item(i).Cell(3,1).Range.Text:=ADOQuery1.fieldbyname('OrderNO').asstring;
         WordDocument1.Tables.Item(i).Cell(3,2).Range.Text:=ADOQuery1.fieldbyname('CustNO').asstring;
         WordDocument1.Tables.Item(i).Cell(3,3).Range.Text:=ADOQuery1.fieldbyname('LastName').asstring+' '+ADOQuery1.fieldbyname('FirstName').asstring;
         WordDocument1.Tables.Item(i).Cell(3,4).Range.Text:=ADOQuery1.fieldbyname('SaleDate').asstring;
         WordDocument1.Tables.Item(i).Cell(3,5).Range.Text:=ADOQuery1.fieldbyname('ShipDate').asstring;
         WordDocument1.Tables.Item(i).Cell(3,6).Range.Text:=ADOQuery1.fieldbyname('ShipVia').asstring;
         j:=5;
         sum:=0;
         While not ADOQuery2.Eof do
         begin
            WordDocument1.Tables.Item(i).Cell(j,1).Range.Text:=ADOQuery2.fieldbyname('PartNO').asstring;
            WordDocument1.Tables.Item(i).Cell(j,2).Range.Text:=ADOQuery2.fieldbyname('Description').asstring;
            WordDocument1.Tables.Item(i).Cell(j,3).Range.Text:=ADOQuery2.fieldbyname('Qty').asstring;
            WordDocument1.Tables.Item(i).Cell(j,4).Range.Text:=formatfloat('###,###.#0',ADOQuery2.fieldbyname('ListPrice').asfloat);
            WordDocument1.Tables.Item(i).Cell(j,5).Range.Text:=formatfloat('###,###.##',ADOQuery2.fieldbyname('Discount').AsFloat);
            WordDocument1.Tables.Item(i).Cell(j,6).Range.Text:=formatfloat('###,###.#0',ADOQuery2.fieldbyname('amount').AsFloat);
            sum:=sum+ADOQuery2.fieldbyname('amount').AsFloat;
            WordDocument1.Tables.Item(i).Cell(j,6).select;
            j:=j+1;
            ADOQuery2.Next;
            if not ADOQuery2.Eof then
               insertoneline;
         end;
         WordDocument1.Tables.Item(i).Cell(j,2).Range.Text:=formatfloat('###,###.#0',sum);
         WordDocument1.Tables.Item(i).Cell(j+1,2).Range.Text:=formatfloat('###,###.#0',ADOQuery1.fieldbyname('Freight').AsFloat);
         WordDocument1.Tables.Item(i).Cell(j+2,2).Range.Text:=formatfloat('###,###.#0',sum+ADOQuery1.fieldbyname('Freight').AsFloat);
         ADOQuery1.Next;
      end;
      WordDocument1.Range.Characters.Last.Delete(emptyparam,ItemIndex);
      WordDocument1.Disconnect;
      WordApplication1.Disconnect;
      ADOQuery1.Active:=false;
      ADOQuery1.SQL.Strings[3]:='';
      ADOQuery1.SQL.Strings[4]:='';
      ADOQuery1.Active:=true;
   end else
   begin
      showmessage('Lk'+s);
   end;
end;

end.
